/**
 * Validates the given config options
 * @param  {unknown} config
 * @param  {object}  config.errorHandler
 * @param  {object}  config.eventDispatcher
 * @param  {object}  config.logger
 * @return {boolean} true if the config options are valid
 * @throws If any of the config options are not valid
 */
export declare const validate: (config: unknown) => boolean;
/**
 * Validates the datafile
 * @param {Object|string}  datafile
 * @return {Object} The datafile object if the datafile is valid
 * @throws If the datafile is not valid for any of the following reasons:
 - The datafile string is undefined
 - The datafile string cannot be parsed as a JSON object
 - The datafile version is not supported
 */
export declare const validateDatafile: (datafile: unknown) => any;
declare const _default: {
    validate: (config: unknown) => boolean;
    validateDatafile: (datafile: unknown) => any;
};
/**
 * Provides utility methods for validating that the configuration options are valid
 */
export default _default;
